(define (string-prefix? prefix string)
  (let ((index (substring-index prefix string)))
    (and index (zero? index))))

(test-assert "Version number is 1.1.0 or greater"
             (>= (openssl-version-number) #x10100000))
(test-assert "Version string starts with OpenSSL <digit>.<digit>.<digit>"
             (irregex-match? "OpenSSL [0-9]\\.[0-9]+\\.[0-9]+.*"
                             (openssl-version openssl/version)))
(test-assert "CFLAGS start with compiler: "
             (string-prefix? "compiler: " (openssl-version openssl/cflags)))
(test-assert "Build date starts with built on: "
             (string-prefix? "built on: " (openssl-version openssl/built-on)))
(test-assert "Platform starts with platform: "
             (string-prefix? "platform: " (openssl-version openssl/platform)))
(test-assert "Dir starts with OPENSSLDIR: "
             (string-prefix? "OPENSSLDIR: " (openssl-version openssl/dir)))
(test-assert "Engines dir starts with ENGINESDIR: "
             (string-prefix? "ENGINESDIR: " (openssl-version openssl/engines-dir)))
